﻿using System;
using System.Collections.Generic;
using System.Collections.ObjectModel;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace Articles.ScriptingCSharp.ScriptFramework.CSharp
{
    public class CSharpScriptFile
    {
        private ObservableCollection<string> m_referencedAssemblies;
        private string m_scriptContent;

        /// <summary>
        /// Initializes a new instance of the <see cref="CSharpScriptFile" /> class.
        /// </summary>
        public CSharpScriptFile()
        {
            m_referencedAssemblies = new ObservableCollection<string>();
            m_scriptContent = string.Empty;

            m_referencedAssemblies.Add("Microsoft.CSharp.dll");
            m_referencedAssemblies.Add("System.dll");
            m_referencedAssemblies.Add("System.Core.dll");
            m_referencedAssemblies.Add("System.Data.dll");
            m_referencedAssemblies.Add("System.Linq.dll");
            m_referencedAssemblies.Add("System.Windows.Forms.dll");

            m_scriptContent =
                "using System;" + Environment.NewLine +
                "using System.Collections.Generic; " + Environment.NewLine +
                "using System.Linq; " + Environment.NewLine +
                "using System.Text; " + Environment.NewLine +
                "using System.Threading.Tasks; " + Environment.NewLine +
                "using System.Windows.Forms; " + Environment.NewLine +
                "" + Environment.NewLine +
                "public class ScriptedClass" + Environment.NewLine +
                "{" + Environment.NewLine +
                "    public static void Execute()" + Environment.NewLine +
                "    {" + Environment.NewLine +
                "        MessageBox.Show(\"Hello World! from script\");" + Environment.NewLine +
                "    }" + Environment.NewLine +
                "}" + Environment.NewLine;
        }

        /// <summary>
        /// Gets the referenced assemblies.
        /// </summary>
        /// <value>
        /// The referenced assemblies.
        /// </value>
        public ObservableCollection<string> ReferencedAssemblies
        {
            get { return m_referencedAssemblies; }
        }

        /// <summary>
        /// Gets or sets the content of the script.
        /// </summary>
        public string ScriptContent
        {
            get { return m_scriptContent; }
            set { m_scriptContent = value; }
        }
    }
}
