﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Shapes;

namespace Articles.ScriptingCSharp.ScriptableApplication
{
    /// <summary>
    /// Interaction logic for AddAssemblyDialog.xaml
    /// </summary>
    public partial class AddAssemblyDialog : Window
    {
        /// <summary>
        /// Initializes a new instance of the <see cref="AddAssemblyDialog" /> class.
        /// </summary>
        public AddAssemblyDialog()
        {
            InitializeComponent();
        }

        /// <summary>
        /// Called when user wants to confirm.
        /// </summary>
        /// <param name="sender">The sender.</param>
        /// <param name="e">The <see cref="RoutedEventArgs" /> instance containing the event data.</param>
        private void OnCmdOKClick(object sender, RoutedEventArgs e)
        {
            this.DialogResult = true;
            this.Close();
        }

        /// <summary>
        /// Called when user wants to cancel.
        /// </summary>
        /// <param name="sender">The sender.</param>
        /// <param name="e">The <see cref="RoutedEventArgs" /> instance containing the event data.</param>
        private void OnCmdCancelClick(object sender, RoutedEventArgs e)
        {
            this.DialogResult = false;
            this.Close();
        }

        /// <summary>
        /// Gets the name of the selected assembly.
        /// </summary>
        public string AssemblyName
        {
            get { return TxtAssemblyName.Text; }
        }
    }
}
